+++
title = 'How everything began - or: the first post!'
date = 2025-04-13T15:10:20+02:00
draft = false
toc = true
cover = '/files/how-it-all-began/cover.png'
+++


## Initial considerations {id=thinking} 

I've been thinking about how to write this post for a long time. What needs to be told, what is unimportant? A lot has to be left out for the sake of clarity, and I might not even remember some of it. In any case, I would like to use this article to explain my intention in starting this blog. But to explain that, you have to understand the origins.


## How it all began {id=beginnings}

It all started when I was a 5th or 6th grade student (I can't remember exactly!) and started writing a batch script on a laptop for school. Yes, that's how it was, I admit - even if I don't know who or what drove me to do it. But I have a rough idea: I think it was a child's intrinsic motivation to find out how this computer in front of him works that made me do it. 

Be that as it may, one of my “programs” looked something like this (yes, partially german):

```batch
@echo off

echo Herzlich Wilkommen , bitte Passwort eingeben
color 7b

:PSWD
set/p x=
if ''%x%''==''sehrsicher'' goto openfile

pause

:false 
echo Falsches Passwort , bitte erneut versuchen.
color 7c
goto PWSD

:openfile
echo Passwort richtig , bitte 'Enter' druecken!
goto Video

pause

:Video
echo Wenn sie sich ein Video anschauen moechten , dann geben sie jetzt ,,Ja`` ein , wenn nicht dann einfach ,,Nein''!
color 7b

:PSWD
set/p x=
if ''%x%''==''Ja'' goto OpenVideo

:false
goto exit

:OpenVideo 
start C:\Users\<CENSORED>\<YES, REALLY>\

:exit
exit
```

Well, then my father gave me the book, a textbook on Python3[^1], and there was no turning back. I think I read the entire textbook when I was 11 or 12 years old. Anyway, at some point I switched to Linux (initially [Linux Mint](https://linuxmint.com/)) - then came COVID-19[^2].


[^1]: [Python3 - das umfassende Handbuch von Johannes Ernesti und Peter Kaiser](https://www.rheinwerk-verlag.de/python-3-das-umfassende-handbuch/) (no advertising!)

[^2]: Then again, it wasn't that easy, but for the sake of clarity I've just simplified here.


## COVID-19 {id=covid-19}

For students, COVID-19 and the associated homeschooling and isolation meant one thing above all: a lot of time. They used it in different ways. I used it to pursue my new hobby intensively. During this time, I learned new programming languages like Java (partly for Minecraft plugins, [here](https://git.privacynerd.de/BlueFox/MC-Plugins) you can find some), and even taught myself some C and assembler. 

During this time, I was given my first Raspberry Pi - with far-reaching consequences. Because it led to me turning more and more to the hardware side. While I had previously written web apps with a database in [Django](https://www.djangoproject.com/) or [Flask](https://flask.palletsprojects.com/en/stable/) and Python, I was now programming simple blinking circuits, then at some point scripts that read sensor data and displayed it on a small OLED display (0.96") or switched the lamps in my room on and off at the touch of a button (because a light switch is not enough!). During this time, I also discovered for myself a 3D printer that had been sitting around almost unused for a long time.

{{< figure src="/files/how-it-all-began/esafep.png" alt="Picture of the ESafeP - a wooden ”safe“ with its own software" caption="The ”ESafeP“ - very stable!" >}}

Things got even more hardware-oriented with my first ESP32 - new ideas emerged and with them new projects. A self-built safe (super safe made of wood!) with my own [software](https://git.privacynerd.de/BlueFox/ESafeP) was just as much a part of it as my own [MP3 (and much more) player](https://git.privacynerd.de/NetSpeaker/NetSpeaker). The 3D printer was also used time and again, as it is common in the DIY space - for example for the housing for my battery-powered [ePaper showing the german ”Tageslosung“ - a verse from the bible for every day](https://git.privacynerd.de/BlueFox/losungepaper).

{{< figure src="/files/how-it-all-began/netspeaker.jpg" alt="Image of a finished, self-made NetSpeaker in housing - which is (not) just MP3 player." caption="A NetSpeaker" >}}

{{< figure src="/files/how-it-all-began/losung-epaper.jpg" alt="Image of the finished ePaper, which displays the current daily verse of the bibel (german ”Tageslosung“)" caption="Losungs-ePaper (showing a biblical verse of the day)" >}}

All in all, the corona pandemic had opened up previously unimagined new spaces, at least for me, and also had its positive sides: During this time, I developed an interest in 3D printing, which could also be the subject of this blog.


## Until now... {id=until-now}

Well, not much has changed since then. At some point, self-hosting got a thing for me, and I also got to know wood as an exciting material (as already mentioned above). It's so cool to see what you can host yourself: your own file synchronization service, your [own Github](https://git.privacynerd.de/), media servers, and so on. Initially, everything ran on the aforementioned Raspberry Pi. Later, however, access from outside the home network was required, and since then many services have been running on a rented server.

{{< figure src="/files/how-it-all-began/gitea-a-self-hosted-github.png" alt="Screenshot of my self-hosted instance of Gitea" caption="A ”self-hosted Github“" >}}

Not so long ago, I had an idea: I was learning to etch circuit boards myself, and the information I was getting was mainly from other makers' blogs. Thus, why not write about what you do? On the one hand, it could actually be that someone looking for it might find their way to the blog, but on the other hand, it's simply a useful way of documenting it, and maybe even something good for future job applications.

{{< figure src="/files/how-it-all-began/etching-station.jpg" alt="Picture of a setup for manually etching circuit boards; in the picture: a self-built UV exposure unit, an etching unit and a container with caustic soda solution" caption="The etching setup" >}}

So, I sat down and looked for ways to create a blog. Of course, it had to be self-hosted, and maybe even a bit self-made. This led me to [Hugo](https://gohugo.io/) (Jekyll was also a consideration), a relatively simple (and very fast) static site generator that can generate websites from Markdown (among other things) and is therefore actually perfect for a blog. When choosing a theme, I initially wavered between ”create it myself“ and ”use an existing one“. Due to a lack of time and for reasons of simplicity, I ended up using an existing one, more precisely [Terminal](https://themes.gohugo.io/themes/hugo-theme-terminal/). Adapted to my needs, the blog itself was already finished relatively quickly[^3]. Now it's just waiting to be filled with content.

[^3]: ...but, to be honest, a few afternoons (and evenings and nights) were spent on it.


## Planned content {id=planned-content}

What you plan at the beginning is rarely implemented in exactly the same way in the end - and that will probably also be the case with this blog, and that's a good thing. After all, everything evolves. But I'm still going to write down what I plan to write on this blog in the future - because I do have a rough idea.

- about my DIY projects,
- about new experiences that I gather while tinkering, 
- also an update here and there on existing projects and libraries of mine,
- and maybe something completely new!

To summarize: everything I do DIY-wise, I would like to share resp. document here (if there is time and inclination) - in the hope that maybe someone will ask themselves the exact same question as me or have a similar idea to mine, and then find their way to this blog.
